{{
    config(
        schema='DW_SALES',
        materialized='incremental',
        unique_key='REGION_SK'
    )
}}

WITH STG_REGION AS
(SELECT DISTINCT R_REGIONKEY as REGION_ID, 
    R_NAME as REGION_NAME, 
    R_REGIONKEY as AUDIT_ROW_NATURAL_KEY,
    MD5(R_NAME) as AUDIT_UPDATE_CHECKSUM
 FROM {{ source('TPCH_SF1', 'REGION') }}
 ORDER BY 1)

 SELECT NVL(D.REGION_SK,DW_SALES.DIM_REGION_SEQ.nextval) REGION_SK, 
    R.REGION_ID, 
    R.REGION_NAME, 
    R.AUDIT_ROW_NATURAL_KEY,
    R.AUDIT_UPDATE_CHECKSUM,
    NVL(D.AUDIT_CREATION_DATE_TIME,SYSDATE()) as AUDIT_CREATION_DATE_TIME,
    SYSDATE() as AUDIT_UPDATE_DATE_TIME,
    '{{ invocation_id }}' AS AUDIT_GUID  
 FROM STG_REGION R
  LEFT JOIN DW_SALES.DIM_REGION D ON (R.AUDIT_ROW_NATURAL_KEY = D.AUDIT_ROW_NATURAL_KEY)
 WHERE R.AUDIT_UPDATE_CHECKSUM <> D.AUDIT_UPDATE_CHECKSUM OR D.AUDIT_UPDATE_CHECKSUM IS NULL

